<!DOCTYPE html>
<html>

<head>
    <title>Game Caro Online</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
</head>

<body>
    <div id="app">
        <template>
            <div v-show="isShowLogin" class="shadow" style="width: 70%; margin: 5% auto; padding-bottom: 20px;">
                <ul class="nav nav-tabs">
                    <li class="active"><a data-toggle="tab" href="#home">Đăng nhập</a></li>
                    <li><a data-toggle="tab" href="#menu1">Đăng ký tài khoản</a></li>
                </ul>

                <div class="tab-content">
                    <div id="home" class="tab-pane fade in active">
                        <h3 class="text-center">Đăng nhập</h3>
                        <form class="form-horizontal" action="/action_page.php"
                            style="margin: 25px auto auto auto; width: 80%;">
                            <div class="form-group">
                                <label class="control-label col-sm-2">Tên đăng nhập:</label>
                                <div class="col-sm-10">
                                    <input type="text" class="form-control" id="userName" ref="Acc"
                                        placeholder="Tên đăng nhập">
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="control-label col-sm-2">Mật khẩu:</label>
                                <div class="col-sm-10">
                                    <input type="password" class="form-control" id="pwd" ref="pwd"
                                        placeholder="Mật khẩu">
                                </div>
                            </div>
                            <div class="form-group">
                                <div class="col-sm-offset-2 col-sm-10">
                                    <button type="submit" class="btn btn-default" @click="HandleLogin($event)">Đăng
                                        nhập</button>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div id="menu1" class="tab-pane fade">
                        <h3 class="text-center">Đăng ký tài khoản</h3>
                        <form class="form-horizontal" action="" style="margin: 25px auto auto auto; width: 80%;">
                            <div class="form-group">
                                <label class="control-label col-sm-2">Tên đăng nhập:</label>
                                <div class="col-sm-10">
                                    <input type="text" class="form-control" id="userName" ref="AccCreate"
                                        placeholder="Tên đăng nhập">
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="control-label col-sm-2">Email:</label>
                                <div class="col-sm-10">
                                    <input type="email" class="form-control" id="email" ref="email" placeholder="email">
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="control-label col-sm-2">Mật khẩu:</label>
                                <div class="col-sm-10">
                                    <input type="password" class="form-control" id="pwd" ref="pwdCreate"
                                        placeholder="Mật khẩu">
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="control-label col-sm-2">Nhập lại mật khẩu:</label>
                                <div class="col-sm-10">
                                    <input type="password" class="form-control" id="pwd" ref="pwdConfirm"
                                        placeholder="Mật khẩu">
                                </div>
                            </div>
                            <div class="form-group">
                                <div class="col-sm-offset-2 col-sm-10">
                                    <button type="submit" class="btn btn-default" @click="HandleRegister($event)">Đăng
                                        ký</button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
    </div>
    <div v-show="!isShowLogin">
        <div class="container" v-show="!isShowTableChess">
            <div class="input-group" style="margin: 20px auto;">
                <input type="text" class="form-control" id="username" placeholder="Tên phòng">
                <span class="input-group-btn">
                    <button type="button" class="btn btn-info" @click="CreateRoom">Tạo phòng</button>
                </span>
            </div>

            <table class="table table-bordered">
                <thead>
                    <tr>
                        <th>Mã phòng</th>
                        <th>Tên phòng</th>
                        <th>action</th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="item in lstIdRoom" :key="item">
                        <!-- item: idRoom_idUser_username -->
                        <td>{{item.split('\<\>')[0]}}</td>
                        <td>{{item.split('\<\>')[2]}}</td>
                        <td>
                            <button type="button" class="btn btn-success" @click="joinRoom(item.split('\<\>')[0])">Vào
                                Trận</button>
                        </td>
                    </tr>
                </tbody>
            </table>

            <div :class="TypeMess" v-show="textAlert !== ''">
                <h1 class="text-center" style="margin: 0;">{{textAlert}}</h1>
            </div>

            <div class="panel panel-info" style="width: 60%; margin: 10% auto 0 auto;">
                <div class="panel-heading">Thống kê lịch sử đấu</div>
                <div class="panel-body">

                    <div class="alert alert-success">
                        <strong>Số trận thắng:</strong> {{numWin}} (trận)
                    </div>
                    <div class="alert alert-warning">
                        <strong>Số trận thua:</strong> {{numLose}} (trận)
                    </div>
                </div>
            </div>
        </div>

        <!-- chessboardPlacer -->
        <div class="container mt-5" v-show="isShowTableChess" id="chessboardPlacer">
            <button type="button" class="btn btn-info" @click="BackRoom">Quay lại phòng chờ</button>
            <h1 class="text-center"><b>Cờ </b><b :class="ColorTypeChessNext">{{TextTypeChessNext}}</b><b> đi cờ
                </b>{{timer}}s</h1>
            <div class="row text-center pt-5" id="chessboardCenterPlacer">

                <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" style="background-color: aqua; height: 900px;">
                    <h1><b>Bạn chơi quân </b><b :class="ColorTypeChessOfUser">{{TextTypeChessOfUser}}</b></h1>
                    <h1></h1>
                    <h1 v-show="isShowWinner"><b>Cờ </b><b :class="ColorTypeChessWin">{{TextTypeChessWin}}</b><b> đã
                            thắng</b></h1>
                </div>

                <div class="col-xs-9">
                    <table id="chessboard"
                        style="display: inline-block; background-color: rgb(255, 191, 0); text-align: left; margin-left: auto; margin-right: auto;"
                        border="1" cellpadding="2" cellspacing="2">
                        <tbody>
                            <tr v-for="(itemtr, indextr) in tableChess" :key="indextr">
                                <td :class="item.chessTable" v-for="(item, index) in itemtr"
                                    :key="indextr + '_' + index">
                                    <button :class="item.chessType" :id="item.chessPos"
                                        v-on:click="onClickChess(item.chessPos, item.chessText)"
                                        :disabled="!isStartGame">
                                        <b>{{item.chessText}}</b>
                                    </button>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
    </template>
    </div>
    <script src="/socket.io/socket.io.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>

    <script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>
    <script src="https://unpkg.com/axios/dist/axios.min.js"></script>

    <!-- <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script> -->
    <script>
        let urlLocal = "http://localhost";
        let urlProd = "https://pttkpm.tk";
        let portLocal = "1337";
        let portProd = "443";
        
        let url = window.location.href;
        let host = url.search("localhost") > 0 ? urlLocal : urlProd;
        var port = url.search("localhost") > 0 ? portLocal : portProd;
        var socket = null;

        setInterval(function () {
            if (!app.isStartGame)
                return
            if (app.timer < 1) {
                if (app.TextTypeChessOfUser === app.TextTypeChessNext) {
                    socket.emit("timeStop")
                }
                if (app.TextTypeChessNext === "X") {
                    app.TextTypeChessWin = "O"
                    app.ColorTypeChessWin = 'red'
                } else {
                    app.TextTypeChessWin = "X"
                    app.ColorTypeChessWin = 'black'
                }
                return
            }
            app.timer -= 1
        }, 1000);
        var app = new Vue({
            el: '#app',
            data: {
                tableChess: [],
                move: false,
                isShowWinner: false,
                isStartGame: false,
                lstChess: [],
                TextTypeChessOfUser: "",
                ColorTypeChessOfUser: "",
                TextTypeChessNext: "X",
                ColorTypeChessNext: "black",
                TextTypeChessWin: "",
                ColorTypeChessWin: "",
                textAlert: "",
                timer: "",
                lstIdRoom: [],
                isShowTableChess: false,
                TypeMess: "alert alert-info",
                isShowLogin: true,
                numWin: 0,
                numLose: 0,
                idUser: ""
            },
            methods: {
                HandleLogin(e) {
                    e.preventDefault()
                    var self = this
                    console.log(`${host}:${port}/auth/local`)
                    axios.post(`${host}:${port}/auth/local`, {
                        "identifier": self.$refs.Acc.value,
                        "password": self.$refs.pwd.value
                    }).then(res => {
                        self.idUser = res.data.user.id
                        self.isShowLogin = false

                        //count iswin
                        axios.get(`${host}:${port}/results?IdUser=${this.idUser}&IsWin=true`)
                            .then(res => {
                                self.numWin = res.data.length
                            }).catch(err => {
                                console.log(err)
                            })

                        //count isLose
                        axios.get(`${host}:${port}/results?IdUser=${this.idUser}&IsWin=false`)
                            .then(res => {
                                self.numLose = res.data.length
                            }).catch(err => {
                                console.log(err)
                            })
                    }).catch(err => {
                        console.log(err)
                        swal("Có Lỗi!", "Tên đăng nhập hoặc mật khẩu khồn chính xác!", "error")
                    })


                },
                HandleRegister(e) {
                    e.preventDefault();
                    var self = this
                    if (self.$refs.pwdCreate.value !== self.$refs.pwdConfirm.value){
                        swal("Có Lỗi!", "Mật khẩu nhập lại không đúng!", "error")
                        return;
                    }
                    axios.post(`${host}:${port}/auth/local/register`, {
                        "username": self.$refs.AccCreate.value,
                        "email": self.$refs.email.value,
                        "password": self.$refs.pwdCreate.value
                    }).then(res => {
                        console.log(res)
                        self.isShowLogin = false
                        self.idUser = res.data.user.id
                    }).catch(err => {
                        console.log(err.response)
                        swal("Có Lỗi!", "Tên đăng nhập hoặc email đã tồn tại!", "error")
                    })

                },
                BackRoom() {
                    if (this.isStartGame) {
                        swal("Bạn đang trong trận!", "", "warning");
                        return
                    }
                    socket.emit("ClearRoomOfUser")
                    this.isShowTableChess = !this.isShowTableChess
                    this.TextTypeChessWin = ''
                    this.ColorTypeChessWin = ''
                    this.isStartGame = false
                    this.isShowWinner = false
                    this.move = false,
                        this.TextTypeChessNext = "X"
                    this.ColorTypeChessNext = "black"
                },
                CreateRoom() {
                    let username = document.getElementById("username").value + ""
                    if (username.trim() === "") {
                        swal("Có lỗi!", "Chưa nhập tên phòng!", "error");
                        document.getElementById("username").focus()
                        return
                    }
                    socket.emit("CreateRoom", document.getElementById("username").value)
                    document.getElementById("username").value = ""
                },
                joinRoom(idRoom) {
                    socket.emit("BeginGame", idRoom)
                },
                onClickChess(pos, text) {
                    if (this.TextTypeChessOfUser !== this.TextTypeChessNext || text.trim() !== "") {
                        return
                    }
                    socket.emit("message", pos, text)
                },

                checkIsWin(pos, text) {
                    let count = 1;
                    let pointX = Number(pos.split("_")[0])
                    let pointY = Number(pos.split("_")[1])
                    // doc
                    while (1) {
                        let chess = (pointX - 1) + "_" + pointY + "@@" + text
                        if (this.lstChess.indexOf(chess) >= 0)
                            count += 1
                        else
                            break;
                        pointX -= 1
                    }
                    pointX = Number(pos.split("_")[0])
                    while (1) {
                        let chess = (pointX + 1) + "_" + pointY + "@@" + text
                        if (this.lstChess.indexOf(chess) >= 0)
                            count += 1
                        else
                            break;
                        pointX += 1
                    }
                    if (count >= 5) return true

                    // ngang
                    count = 1
                    while (1) {
                        let chess = pointX + "_" + (pointY - 1) + "@@" + text
                        if (this.lstChess.indexOf(chess) >= 0)
                            count += 1
                        else
                            break;
                        pointY -= 1
                    }
                    pointY = Number(pos.split("_")[1])
                    while (1) {
                        let chess = pointX + "_" + (pointY + 1) + "@@" + text
                        if (this.lstChess.indexOf(chess) >= 0)
                            count += 1
                        else
                            break;
                        pointY += 1
                    }
                    if (count >= 5) return true

                    // diagonal line main
                    count = 1
                    pointX = Number(pos.split("_")[0])
                    pointY = Number(pos.split("_")[1])
                    while (1) {
                        let chess = (pointX - 1) + "_" + (pointY + 1) + "@@" + text
                        if (this.lstChess.indexOf(chess) >= 0)
                            count += 1
                        else
                            break;
                        pointX -= 1
                        pointY += 1
                    }
                    pointX = Number(pos.split("_")[0])
                    pointY = Number(pos.split("_")[1])
                    while (1) {
                        let chess = (pointX + 1) + "_" + (pointY - 1) + "@@" + text
                        if (this.lstChess.indexOf(chess) >= 0)
                            count += 1
                        else
                            break;
                        pointX += 1
                        pointY -= 1
                    }
                    if (count >= 5) return true

                    // diagonal line
                    count = 1
                    pointX = Number(pos.split("_")[0])
                    pointY = Number(pos.split("_")[1])
                    while (1) {
                        let chess = (pointX - 1) + "_" + (pointY - 1) + "@@" + text
                        if (this.lstChess.indexOf(chess) >= 0)
                            count += 1
                        else
                            break;
                        pointX -= 1
                        pointY -= 1
                    }
                    pointX = Number(pos.split("_")[0])
                    pointY = Number(pos.split("_")[1])
                    while (1) {
                        let chess = (pointX + 1) + "_" + (pointY + 1) + "@@" + text
                        if (this.lstChess.indexOf(chess) >= 0)
                            count += 1
                        else
                            break;
                        pointX += 1
                        pointY += 1
                    }
                    if (count >= 5) return true

                    return false
                },
            },
            created: function () {
                for (let i = 0; i < 20; i++) {
                    let rowChess = [];
                    for (let j = 0; j < 20; j++) {
                        rowChess.push({
                            chessText: "　",
                            chessType: "neutral",
                            chessTable: "red",
                            chessPos: `${i}_${j}`
                        });
                    }
                    this.tableChess.push(rowChess);
                }
                socket = io(host + ":" + port);
            },
            mounted: function () {
                socket.on('message', function (messToSV) {
                    let pointX = Number(messToSV.pos.split("_")[0])
                    let pointY = Number(messToSV.pos.split("_")[1])
                    let d = document.getElementsByClassName("chess-active")
                    if (d.length > 0) {
                        d[0].className = d[0].className.replace(" chess-active", "")
                    }
                    let text = app.move ? "O" : "X";
                    let color = app.move ? "red chess-active" : "black chess-active";
                    app.tableChess[pointX][pointY].chessText = text
                    app.tableChess[pointX][pointY].chessType = color;
                    app.move = !app.move
                    app.lstChess.push(messToSV.pos + "@@" + text)
                    if (app.checkIsWin(messToSV.pos, text)) {
                        app.TextTypeChessWin = text
                        app.ColorTypeChessWin = color
                        app.textAlert = "Trận đấu kết thúc"
                        app.isStartGame = false
                        app.isShowWinner = true
                        if (app.TextTypeChessWin === app.TextTypeChessOfUser)
                            socket.emit("GameOver", true, app.TextTypeChessWin) //game over
                    }
                    app.curChess = !app.curChess
                    app.TextTypeChessNext = text === "X" ? "O" : "X"
                    app.ColorTypeChessNext = app.move ? "red" : "black"
                    app.timer = 60
                    app.$nextTick(function () {
                    });
                });

                socket.on('TypeChess', function (messToSV) {
                    app.TextTypeChessOfUser = messToSV.text
                    app.ColorTypeChessOfUser = messToSV.color
                });

                socket.on('StartGame', function (messToSV) {
                    app.textAlert = messToSV.indexUser === 1 ? "Chưa có người chơi cùng" : "Bắt đầu trận"
                    app.isStartGame = messToSV.startGame
                    app.timer = messToSV.indexUser === 1 ? 0 : 60
                });

                socket.on('ReceiveBeginGame', function (messToSV) {
                    if (messToSV === 1) {
                        swal("Cảnh báo!", "Phòng đã đầy!", "warning");
                        return
                    } else if (messToSV === 2) {
                        swal("Cảnh báo!", "Bạn đang là trưởng phòng!", "warning");
                        return
                    }
                    app.isShowTableChess = true
                    app.tableChess = []
                    app.lstChess = []
                    for (let i = 0; i < 20; i++) {
                        let rowChess = [];
                        for (let j = 0; j < 20; j++) {
                            rowChess.push({
                                chessText: "　",
                                chessType: "neutral",
                                chessTable: "red",
                                chessPos: `${i}_${j}`
                            });
                        }
                        app.tableChess.push(rowChess);
                    }
                    app.isStartGame = true
                });
                socket.on('OutGame', function (messToSV) {
                    console.log(messToSV)
                    swal("Bạn thắng!", "Đối thủ bỏ cuộc!", "success");
                    app.textAlert = "Đối thủ bỏ cuộc"
                    app.isStartGame = messToSV.startGame
                    app.TextTypeChessWin = app.TextTypeChessOfUser
                    app.ColorTypeChessWin = app.ColorTypeChessOfUser
                    app.isStartGame = false
                    app.isShowWinner = true
                    app.TextTypeChessOfUser = ""
                    app.ColorTypeChessOfUser = ""
                    app.TextTypeChessNext = "X"
                    app.ColorTypeChessNext = "black"
                    // app.numWin += 1
                    axios.post(`${host}:${port}/results`, {
                        "IdUser": app.idUser,
                        "IsWin": true
                    }).then(res => {
                        app.numWin += 1
                    }).catch(err => {
                        console.log(err)
                    })
                });
                socket.on('receiveTimeStop', function (isWiner) {
                    if (isWiner) {
                        app.TypeMess = "alert alert-success"
                        app.textAlert = "Đối thủ bỏ cuộc"
                        swal("Đối thủ bỏ cuộc!", "Bạn thắng", "success");
                        app.isStartGame = false
                        app.TextTypeChessWin = app.TextTypeChessOfUser
                        app.ColorTypeChessWin = app.ColorTypeChessOfUser
                        app.isStartGame = false
                        app.isShowWinner = true
                        // app.numWin += 1
                        axios.post(`${host}:${port}/results`, {
                            "IdUser": app.idUser,
                            "IsWin": true
                        }).then(res => {
                            app.numWin += 1
                        }).catch(err => {
                            console.log(err)
                        })
                    } else {
                        app.TypeMess = "alert alert-danger"
                        app.textAlert = "Bạn hết thời gian"
                        app.isStartGame = false
                        app.TextTypeChessWin = app.TextTypeChessOfUser ? "O" : "X"
                        app.ColorTypeChessWin = app.ColorTypeChessOfUser ? "red" : "black"
                        app.isStartGame = false
                        app.isShowWinner = true
                        swal("Bạn hết thời gian!", "", "warning");
                        // app.numLose += 1
                        axios.post(`${host}:${port}/results`, {
                            "IdUser": app.idUser,
                            "IsWin": false
                        }).then(res => {
                            app.numLose += 1
                        }).catch(err => {
                            console.log(err)
                        })
                    }
                });
                socket.on('lstIdRoomFromSV', function (lstIdRoomSV) {
                    app.lstIdRoom = JSON.parse(JSON.stringify(lstIdRoomSV))
                });
                socket.on('Existmanager', function () {
                    app.TypeMess = "alert alert-warning"
                    app.textAlert = "Bạn đã có phòng"
                });
                socket.on('GameOverFromSV', function (TextTypeChessWinFromSV) {
                    console.log('TextTypeChessWinFromSV', TextTypeChessWinFromSV)
                    if (app.TextTypeChessOfUser.trim() === TextTypeChessWinFromSV) {
                        swal("Bạn đã thắng!", "", "success");

                        axios.post(`${host}:${port}/results`, {
                            "IdUser": app.idUser,
                            "IsWin": true
                        }).then(res => {
                            app.numWin += 1
                        }).catch(err => {
                            console.log(err)
                        })
                    } else {
                        swal("Bạn đã thua!", "", "warning");
                        axios.post(`${host}:${port}/results`, {
                            "IdUser": app.idUser,
                            "IsWin": false
                        }).then(res => {
                            app.numLose += 1
                        }).catch(err => {
                            console.log(err)
                        })
                    }

                });
            }
        });
    </script>
    <!-- <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"
        integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa"
        crossorigin="anonymous"></script> -->
</body>


<style scoped>
    #chessboardCenterPlacer {
        width: 100%;
    }

    div.left {
        width: 33%;
        float: left;
    }

    div.center {
        width: 34%;
        float: left;
    }

    div.right {
        width: 33%;
        float: left;
    }

    button.black {
        background-color: #777700;
        border-color: #777700;
        color: #000000;
        font-size: 20px;
        text-align: center;
    }

    button.white {
        background-color: #777700;
        border-color: #777700;
        color: #ffffff;
        font-size: 20px;
        text-align: center;
    }

    button.neutral {
        background-color: #ffffff;
        border-color: #777700;
        color: #ffffff;
        font-size: 20px;
        text-align: center;
        width: 100% !important;
        /* height: 30px !important; */
    }

    button.red {
        background-color: #7f7f00;
        border-color: #7f7f00;
        color: #ff0000;
        font-size: 20px;
        text-align: center;
        width: 100% !important;
    }

    button.black {
        background-color: #7f7f00;
        border-color: #7f7f00;
        color: #000000;
        font-size: 20px;
        text-align: center;
        width: 100% !important;
    }

    b.red {
        color: #ff0000;
    }

    b.black {
        color: #000000;
    }

    td {
        padding: 2px;
    }

    td.red {
        background-color: #7f0000;
    }

    td.black {
        background-color: #7f7f7f;
    }

    .chess-active {
        border-color: chartreuse !important;
    }

    .shadow {
        -webkit-box-shadow: 3px 3px 5px 6px #ccc;
        /* Safari 3-4, iOS 4.0.2 - 4.2, Android 2.3+ */
        -moz-box-shadow: 3px 3px 5px 6px #ccc;
        /* Firefox 3.5 - 3.6 */
        box-shadow: 3px 3px 5px 6px #ccc;
        /* Opera 10.5, IE 9, Firefox 4+, Chrome 6+, iOS 5 */
    }

    .nav-tabs {
        background-color: #8bc348 !important;
    }
</style>

</html>